1#!/bin/sh
2
3#  FLAC - Free Lossless Audio Codec
4#  Copyright (C) 2001,2002,2003,2004,2005,2006,2007  Josh Coalson
5#
6#  This file is part the FLAC project.  FLAC is comprised of several
7#  components distributed under difference licenses.  The codec libraries
8#  are distributed under Xiph.Org's BSD-like license (see the file
9#  COPYING.Xiph in this distribution).  All other programs, libraries, and
10#  plugins are distributed under the GPL (see COPYING.GPL).  The documentation
11#  is distributed under the Gnu FDL (see COPYING.FDL).  Each file in the
12#  FLAC distribution contains at the top the terms under which it may be
13#  distributed.
14#
15#  Since this particular file is relevant to all components of FLAC,
16#  it may be distributed under the Xiph.Org license, which is the least
17#  restrictive of those mentioned above.  See the file COPYING.Xiph in this
18#  distribution.
19
20die ()
21{
22	echo $* 1>&2
23	exit 1
24}
25
26if [ x = x"$1" ] ; then 
27	BUILD=debug
28else
29	BUILD="$1"
30fi
31
32LD_LIBRARY_PATH=../src/libFLAC/.libs:$LD_LIBRARY_PATH
33LD_LIBRARY_PATH=../src/share/grabbag/.libs:$LD_LIBRARY_PATH
34LD_LIBRARY_PATH=../src/share/getopt/.libs:$LD_LIBRARY_PATH
35LD_LIBRARY_PATH=../src/share/replaygain_analysis/.libs:$LD_LIBRARY_PATH
36LD_LIBRARY_PATH=../src/share/replaygain_synthesis/.libs:$LD_LIBRARY_PATH
37LD_LIBRARY_PATH=../src/share/utf8/.libs:$LD_LIBRARY_PATH
38LD_LIBRARY_PATH=../obj/$BUILD/lib:$LD_LIBRARY_PATH
39export LD_LIBRARY_PATH
40PATH=../src/flac:$PATH
41PATH=../obj/$BUILD/bin:$PATH
42BINS_PATH=../../test_files/bins
43
44if [ x"$FLAC__TEST_LEVEL" = x ] ; then
45	FLAC__TEST_LEVEL=1
46fi
47
48flac --help 1>/dev/null 2>/dev/null || die "ERROR can't find flac executable"
49
50run_flac ()
51{
52	if [ x"$FLAC__TEST_WITH_VALGRIND" = xyes ] ; then
53		echo "valgrind --leak-check=yes --show-reachable=yes --num-callers=100 flac $*" >>test_bins.valgrind.log
54		valgrind --leak-check=yes --show-reachable=yes --num-callers=100 --log-fd=4 flac $* 4>>test_bins.valgrind.log
55	else
56		flac $*
57	fi
58}
59
60test -d ${BINS_PATH} || exit 77
61
62test_file ()
63{
64	name=$1
65	channels=$2
66	bps=$3
67	encode_options="$4"
68
69	echo -n "$name.bin (--channels=$channels --bps=$bps $encode_options): encode..."
70	cmd="run_flac --verify --silent --force --force-raw-format --endian=big --sign=signed --sample-rate=44100 --bps=$bps --channels=$channels $encode_options --no-padding $name.bin"
71	echo "### ENCODE $name #######################################################" >> ./streams.log
72	echo "###    cmd=$cmd" >> ./streams.log
73	$cmd 2>>./streams.log || die "ERROR during encode of $name"
74
75	echo -n "decode..."
76	cmd="run_flac --silent --force --endian=big --sign=signed --decode --force-raw-format $name.flac";
77	echo "### DECODE $name #######################################################" >> ./streams.log
78	echo "###    cmd=$cmd" >> ./streams.log
79	$cmd 2>>./streams.log || die "ERROR during decode of $name"
80
81	ls -1l $name.bin >> ./streams.log
82	ls -1l $name.flac >> ./streams.log
83	ls -1l $name.raw >> ./streams.log
84
85	echo -n "compare..."
86	cmp $name.bin $name.raw || die "ERROR during compare of $name"
87
88	echo OK
89}
90
91echo "Testing bins..."
92for f in b00 b01 b02 b03 b04 ; do
93	binfile=$BINS_PATH/$f
94	if [ -f $binfile.bin ] ; then
95		for disable in '' '--disable-verbatim-subframes --disable-constant-subframes' '--disable-verbatim-subframes --disable-constant-subframes --disable-fixed-subframes' ; do
96			for channels in 1 2 4 8 ; do
97				for bps in 8 16 24 ; do
98					for opt in 0 1 2 4 5 6 8 ; do
99						for extras in '' '-p' '-e' ; do
100							for blocksize in '' '--lax -b 32' '--lax -b 32768' '--lax -b 65535' ; do
101								test_file $binfile $channels $bps "-$opt $extras $blocksize $disable"
102							done
103						done
104					done
105					if [ "$FLAC__TEST_LEVEL" -gt 1 ] ; then
106						test_file $binfile $channels $bps "--lax -b 16384 -m -r 8 -l 32 -e -p $disable"
107					fi
108				done
109			done
110		done
111	else
112		echo "$binfile not found, skipping."
113	fi
114done
115